Project Chrono: chrono::fea::ChBeamSectionCosseratEasyCircular Class Reference

Public Member Functions | List of all members
chrono::fea::ChBeamSectionCosseratEasyCircular Class Reference
Chrono::Engine » Finite Element Analysis » Utility classes

## Description

A simple specialization of ChBeamSectionCosserat if you do not need to define its separate models for elasticity, plasticity, damping and inertia.

Good if you just need the simplest model for a circular centered beam. This section automatically creates, initializes and embeds, at construction, these models:

- elasticity: ChElasticityCosseratSimple
- inertia: ChInertiaCosseratSimple
- damping: none - you can add it later
- plasticity: none

`#include <ChBeamSectionCosserat.h>`

Inheritance diagram for chrono::fea::ChBeamSectionCosseratEasyCircular:
[legend]
Collaboration diagram for chrono::fea::ChBeamSectionCosseratEasyCircular:
[legend]

## Public Member Functions
| ChBeamSectionCosseratEasyCircular (double diameter, double E, double G, double density)
Public Member Functions inherited from chrono::fea::ChBeamSectionCosserat
| ChBeamSectionCosserat (std::shared_ptr< ChInertiaCosserat > minertia, std::shared_ptr< ChElasticityCosserat > melasticity, std::shared_ptr< ChPlasticityCosserat > mplasticity={}, std::shared_ptr< ChDampingCosserat > mdamping={})
virtual void | ComputeStress (ChVector3d &stress_n, ChVector3d &stress_m, const ChVector3d &strain_e, const ChVector3d &strain_k, ChBeamMaterialInternalData *mdata_new=nullptr, const ChBeamMaterialInternalData *mdata=nullptr)
| Compute the generalized cut force and cut torque, given the actual generalized section strain expressed as deformation vector e and curvature k, that is: {F,M}=f({e,k}), and given the actual material state required for plasticity if any (but if mdata=nullptr, computes only the elastic force).
virtual void | ComputeStiffnessMatrix (ChMatrix66d &K, const ChVector3d &strain_e, const ChVector3d &strain_k, const ChBeamMaterialInternalData *mdata=nullptr)
| Compute the 6x6 tangent material stiffness matrix [Km] = dσ/dε Compute the 6x6 tangent material stiffness matrix [Km] = dσ/dε at a given strain state, and at given internal data state (if mdata=nullptr, computes only the elastic tangent stiffenss, regardless of plasticity).
void | SetElasticity (std::shared_ptr< ChElasticityCosserat > melasticity)
| Set the elasticity model for this section.
std::shared_ptr< ChElasticityCosserat > | GetElasticity ()
| Get the elasticity model for this section.
void | SetPlasticity (std::shared_ptr< ChPlasticityCosserat > mplasticity)
| Set the plasticity model for this section.
std::shared_ptr< ChPlasticityCosserat > | GetPlasticity ()
| Get the elasticity model for this section, if any.
void | SetInertia (std::shared_ptr< ChInertiaCosserat > minertia)
| Set the inertial model for this section, that defines the mass per unit length and the inertia tensor of the section.
std::shared_ptr< ChInertiaCosserat > | GetInertia ()
| Get the inertial model for this section, if any.
void | SetDamping (std::shared_ptr< ChDampingCosserat > mdamping)
| Set the damping model for this section.
std::shared_ptr< ChDampingCosserat > | GetDamping ()
| Get the damping model for this section.
Public Member Functions inherited from chrono::fea::ChBeamSection
void | SetDrawShape (std::shared_ptr< ChBeamSectionShape > mshape)
| Set the graphical representation for this section.
std::shared_ptr< ChBeamSectionShape > | GetDrawShape () const
| Get the drawing shape of this section (i.e.a 2D profile used for drawing 3D tesselation and visualization) By default a thin square section, use SetDrawShape() to change it.
void | SetDrawThickness (double thickness_y, double thickness_z)
| Shortcut: adds a ChBeamSectionShapeRectangular for visualization as a centered rectangular beam, and sets its width/height.
void | SetDrawCircularRadius (double draw_rad)
| Shortcut: adds a ChBeamSectionShapeCircular for visualization as a centered circular beam, and sets its radius.
void | SetCircular (bool ic)
| OBSOLETE only for backward compability.

## Constructor & Destructor Documentation

## ◆ ChBeamSectionCosseratEasyCircular()

chrono::fea::ChBeamSectionCosseratEasyCircular::ChBeamSectionCosseratEasyCircular | ( | double | diameter,
|  | double | E,
|  | double | G,
|  | double | density )

Parameters

  diameter | diameter of section
  E | Young modulus
  G | shear modulus
  density | volumetric density (ex. in SI units: [kg/m^3])

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChBeamSectionCosserat.h
- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChBeamSectionCosserat.cpp